<?php
defined('BASEPATH') OR exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *'); 

class Note extends CI_Controller {
    public function __construct() 
    {
        parent::__construct();  
    }

    public function notes($userid){
        //$post_data = json_decode(file_get_contents('php://input'), true);
        $prefix = '';
    	$spn ="call ptsl_get_notes('".$userid."', '".$prefix."')";
        $data = $this->db->query($spn)->result_array();
    	 if($data){
             $response = array(
                'status' => TRUE,
                'notes' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function notes_search(){
        $post_data = json_decode(file_get_contents('php://input'), true);
        $prefix = @$post_data['prefix'];
        $userid= @$post_data['user_id'];
        $spn ="call ptsl_get_notes('".$userid."', '".$prefix."')";
        $data = $this->db->query($spn)->result_array();
         if($data){
             $response = array(
                'status' => TRUE,
                'notes' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function note($id){
    	$this->db->where('noteid',$id);
    	$data = $this->db->get('ptsl_notes')->row();
    	 if($data){
             $response = array(
                'status' => TRUE,
                'note' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function add(){
    	$post_data = json_decode(file_get_contents('php://input'), true);
    	$note = @$post_data['note'];
    	$title= @$post_data['title'];
    	$user_id = @$post_data['user_id'];
    	if(!$note){
    		$response = array(
                'status' => False,
                'message' => 'Note is required'
            );
            echo json_encode($response);
    	}
    	else{
    		$data = array(
    			'user_id' => $user_id,
    			'createddate'=> date('Y-m-d'),
    			'title' => $title,
    			'note' => $note
    		);
    		$result = $this->db->insert('ptsl_notes',$data);
    		if($result){
    			$response = array(
    	            'status' => TRUE,
    	            'message' => 'Note added successfully'
    	        );
    	        echo json_encode($response);
    		}
    		else{
    			$response = array(
    	            'status' => False,
    	            'message' => 'Error! Note cannot be added'
    	        );
    	        echo json_encode($response);
    		}	
    	}
    }
    public function delete($id){
    	$data = array(
    		'status' =>0,
    		'deleteddate' => date('Y-m-d')
    	);
    	$this->db->where('noteid',$id);
    	$result = $this->db->update('ptsl_notes',$data);
    	if($result){
    			$response = array(
    	            'status' => TRUE,
    	            'message' => 'Note deleted successfully'
    	        );
    	        echo json_encode($response);
    		}
    		else{
    			$response = array(
    	            'status' => False,
    	            'message' => 'Error! Note cannot be deleted'
    	        );
    	        echo json_encode($response);
    		}	
    }
    public function update($id){
    	$post_data = json_decode(file_get_contents('php://input'), true);
    	$note = @$post_data['note'];
    	$title= @$post_data['title'];
    	$user_id = @$post_data['user_id'];
    	/*if(!$note){
    		$response = array(
                'status' => False,
                'message' => 'Note is required'
            );
            echo json_encode($response);
    	}
    	else if(!$title){
    		$response = array(
                'status' => False,
                'message' => 'Note is required'
            );
            echo json_encode($response);
    	}else{*/
    		$data = array(
    			'user_id' => $user_id,
    			'updateddate'=> date('Y-m-d'),
    		);
    		if($note){
    			$data['note'] = $note;
    		}
    		if($title){
    			$data['title'] = $title;
    		}
    		$this->db->where('noteid',$id);
    		$result = $this->db->update('ptsl_notes',$data);
    		if($result){
    			$response = array(
    	            'status' => TRUE,
    	            'message' => 'Note updated successfully'
    	        );
    	        echo json_encode($response);
    		}
    		else{
    			$response = array(
    	            'status' => False,
    	            'message' => 'Error! Note cannot be updated'
    	        );
    	        echo json_encode($response);
    		}	
    	//}
    }
}