<?php
defined('BASEPATH') OR exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *'); 

class Recent_acitivity extends CI_Controller {
    public function __construct() 
    {
        parent::__construct();
        $this->load->library('Multiquery');  
    }

    public function index(){
    	/*$this->db->select('accinfo.LongName,activity.ActivityID,date_format(activity.CreatedDate,"%M %d , %Y") as date,activity.isEvent,subtype.SubtypeName');
    	$this->db->from('ptsl_account_activity activity');
    	$this->db->join('ptsl_activitysubtype subtype','subtype.ActivitySubtypeID = activity.ptsl_activitySubtype_ActivitySubtypeID','');
    	$this->db->join('ptsl_accountinfo accinfo','accinfo.AccountID = activity.AccountID','');
    	$this->db->join('ptsl_clientrep rep','rep.ClientRepID = activity.Client_Rep_ID','');
    	$data = $this->db->get()->result_array();*/
    	$sql ="SELECT * FROM `ptsl_account_activity` `activity` JOIN `ptsl_activitysubtype` `subtype` ON `subtype`.`ActivitySubtypeID` = `activity`.`ptsl_activitySubtype_ActivitySubtypeID` JOIN `ptsl_accountinfo` `accinfo` ON `accinfo`.`AccountID` = `activity`.`AccountID` JOIN `ptsl_clientrep` `rep` ON `rep`.`ClientRepID` = `activity`.`Client_Rep_ID`";
    	$data = $this->db->query($sql)->result_array();
    	if($data){
    		$response = array(
    			'status' => TRUE,
    			'recent_activities' => $data
    		);
    		echo json_encode($response);
    	}
    	else{
    		$response = array(
    			'status' => FALSE,
    			'message' => 'No data Found'
    		);
    		echo json_encode($response);
    	}
    }
    public function account_activity_list($id){
          // $sql = "select IFNULL(ac.isEvent,0) as ch_ev, a.ClientRepName,accinfo.Longname,ac.ActivityID,subtype.SubtypeName, date_format(ac.ActivityDate, '%M %d, %Y') as date from ptsl_account_activity ac LEFT  JOIN ptsl_clientrep a on a.ClientRepID = ac.Client_Rep_ID join ptsl_activitysubtype subtype on `subtype`.`ActivitySubtypeID` = `ac`.`ptsl_activitySubtype_ActivitySubtypeID`  join `ptsl_accountinfo` `accinfo` ON `accinfo`.`AccountID` = `ac`.`AccountID` where ac.AccountID='".$id."' order by ActivityDate DESC";
            $this->db->select('*');
           $this->db->from('ptsl_vw_account_activity');
           $this->db->where('AccountID',$id);
           $this->db->order_by('ActivityDate','desc');
           $data =$this->db->get()->result_array();
        if($data){
            $response = array(
                'status' => TRUE,
                'recent_activities' => $data
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        }
    }
    public function filters(){
        $status = $this->db->get('ptsl_accountstatus')->result_array();
        $channel = $this->db->get('ptsl_accountchannel')->result_array();
        $type = $this->db->get('ptsl_activitytype')->result_array();
        $data['status'] = $status;
        $data['channel'] = $channel;
        $data['type'] = $type;
        $user_id = @$this->input->get('user_id');
        $spn = "Call ptsl_sp_get_brand_list('".$user_id."')";
        $res = $this->multiquery->GetResults($spn);
        $data['brands'] = $res[2];
        $response = array(
                'status' => TRUE,
                'filters' => $data
            );
            echo json_encode($response);
    }
    public function filter9(){
    	$state = @$this->input->get('state');
    	$state2 = @$this->input->get('state2');
        $region_name = @urldecode($this->input->get('region'));
        $rep = @$this->input->get('rep');
        $status = @$this->input->get('status');
        $channel = @$this->input->get('channel');
        $type = @$this->input->get('type');

        $region ="";
        $supplier_id = @$this->input->get('supplier_id');
        $supplier_rep = @$this->input->get('supplier_rep');
        if($supplier_rep && $supplier_rep!="null" && !$rep){
            $rep = $supplier_rep;
        }
        if($region_name){
            $this->db->where('regionname',$region_name);
            $data7 = $this->db->get('ptsl_region')->result_array();
            $region = $data7[0]['id'];
        }
        
        if($supplier_id){
            $this->db->where('supplier_id',$supplier_id);
        }
        if($region){
            $this->db->where('regionid',$region);
        }
        if($state){
            $this->db->where('state',$state);
        }
        if($state2){
        	$this->db->where('state',$state2);
        }
        if($rep){
            $this->db->where('Client_Rep_ID',$rep);
        }
        if($status){
        	$this->db->where('account_status_id',$status);
        }
        if($channel){
        	$this->db->where('ptsl_accountchannel_accountChannelID',$channel);
        }
        if($type){
            $this->db->where('ptsl_activitySubtype_ActivitySubtypeID',$type);
        }
        $data = $this->db->get('ptsl_vw_account_activity')->result_array();
    
    	if($data){
    		$response = array(
    			'status' => TRUE,
    			'recent_activities' => $data
    		);
    		echo json_encode($response);
    	}
    	else{
    		$response = array(
    			'status' => FALSE,
    			'message' => 'No data Found'
    		);
    		echo json_encode($response);
    	}
    }
    public function dist_filter9(){
        $state = @$this->input->get('state');
        $state2 = @$this->input->get('state2');
        $region_name = @urldecode($this->input->get('region'));
        $rep = @$this->input->get('rep');
        $brand = @$this->input->get('brand');
        $channel = @$this->input->get('channel');
        $type = @$this->input->get('type');

        $region ="";
        $distributor_id = @$this->input->get('dist_id');
        $dist_rep = @$this->input->get('dist_rep');
        $dist_manager = @$this->input->get('dist_manager');
        $bm = @$this->input->get('bm');
        $gsm = @$this->input->get('gsm');
        $bms =@$this->input->get('bms');
        /*$supplier_rep = @$this->input->get('supplier_rep');
        if($supplier_rep && $supplier_rep!="null" && !$rep){
            $rep = $supplier_rep;
        }*/
        if(!$region_name){
            if($dist_manager && $dist_manager!='null'){
                $dist_data = $this->db->get_where('ptsl_distributormanager',array('Dist_ManagerID'=>$dist_manager))->result_array();
                $region = $dist_data[0]['regionid'];
            }
            else if($dist_rep && $dist_rep!='null'){
                $dist_rep_data = $this->db->get_where('ptsl_distributorrep',array('Dis_rep_id'=>$dist_rep))->result_array();
                $manager = $dist_rep_data[0]['ptsl_DistributorManager_Dist_ManagerID'];
                $dist_data = $this->db->get_where('ptsl_distributormanager',array('Dist_ManagerID'=>$manager))->result_array();
                $region = $dist_data[0]['regionid'];
            }
        }
        if($region_name){
            $this->db->where('regionname',$region_name);
            $data7 = $this->db->get('ptsl_region')->result_array();
            $region = $data7[0]['id'];
        }
        
        if($distributor_id){
            $this->db->where('distributor_id',$distributor_id);
        }
        if($region){
            $this->db->where('regionid',$region);
        }
        if($state){
            $this->db->where('state',$state);
        }
        if($state2){
            $this->db->where('state',$state2);
        }
        if($rep){
            $this->db->where('Client_Rep_ID',$rep);
        }
        if($brand){
            $this->db->where('supplier_id',$brand);
        }
        if($channel){
            $this->db->where('ptsl_accountchannel_accountChannelID',$channel);
        }
        if($type){
            $this->db->where('ptsl_activitySubtype_ActivitySubtypeID',$type);
        }
        if($bms && $bms!="null"){
            $this->db->where('supplier_id',$bms);
        }
        $data = $this->db->get('ptsl_vw_account_activity')->result_array();
       echo $this->db->last_query(); //xit
        if($data){
            $response = array(
                'status' => TRUE,
                'recent_activities' => $data
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        }
    }
    public function region(){
        $user_id = @$this->input->get('user_id');
        $spn = "call ptsl_get_region_list('".$user_id."')";
        $data = $this->multiquery->GetResults($spn);
        if($data){
            $response = array(
                'status' => TRUE,
                'region' => $data[1]
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        }
    }
    public function representative(){
        $user_id =  @$this->input->get('user_id');
        $spn = "call ptsl_sp_get_supplier_rep_list('".$user_id."')";
        $result = $this->multiquery->GetResults($spn);
        if($result){
            $response = array(
                'status' => TRUE,
                'users' => $result[2]
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        }
    }
    public function filter9_v2(){
        $state = trim(@$this->input->get('state'));
        //$state = trim(@$this->input->get('state2'));
        $region = trim($this->input->get('region'));
        $rep = trim(@$this->input->get('rep'));
        $status = trim(@$this->input->get('status'));
        $channel = trim(@$this->input->get('channel'));
        $type = trim(@$this->input->get('type'));
        $user_id  = trim($this->input->get('user_id'));
        $brand_id = trim(@$this->input->get('brand_id'));
        $ismap_input = @$this->input->get('ismap');
        $range = @$this->input->get('range');
        $is_dist_action = @$this->input->get('has_dist_action');
        if($ismap_input ==1){
            $ismap = 1;
        }else{
            $ismap = 0;
        }
        $spn="Call ptsl_sp_get_recent_activity('".$user_id."','".$status."','".$channel."','".$type."','".$state."','".$region."','".$rep."','".$brand_id."','".$ismap."','".$range."','".$is_dist_action."')";
        //echo $spn;
        $data = $this->multiquery->GetResults($spn);
        if($data){
            $cnt = 0;
            foreach($data[2] as $key=>$rec_data){
                $name = $rec_data['Longname'];
                $address = $rec_data['address_map'];
                $link = '<div class="sum2">'.'<a href="#/clientresult/'.$rec_data["AccountID"].'">Go to Account</a></div>';
                $geocode_array[$cnt][0] = '<div class="summary">'.$name.'</div>'.'<br /><br />'.$address.'<br/><br/>'.$link;
                $geocode_array[$cnt][1] = $rec_data['latitude'];
                $geocode_array[$cnt][2] = $rec_data['longitude'];
                $cnt++;
            }
            $response = array(
                'status' => TRUE,
                'recent_activities' => @$data[2],
                'locations' => $geocode_array,
                'len' => count($geocode_array)
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        }

    }
    public function suppliers(){
        $distributor_id = $this->input->get('dist_id');
        $this->db->select('sup.id,sup.supplier_name');
        $this->db->from('ptsl_supplier sup');
        $this->db->join('ptsl_distributor_supplier dist_sup','sup.id=dist_sup.supplier_id','');
        $this->db->where('dist_sup.distributor_id',$distributor_id);
        $data = $this->db->get()->result_array();
        if($data){
            $response = array(
                'status' => TRUE,
                'suppliers' => $data
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        }
    }
    public function update(){
        $dates = $this->db->query('SELECT ActivityID, date(CreatedDate) as cd FROM `ptsl_account_activity`')->result_array();
        foreach ($dates as $key => $date) {
            echo $date['cd'];
            $data= array(
                'ActivityDate' => $date['cd']
            );
            $this->db->where('ActivityID',$date['ActivityID']);
            $this->db->update('ptsl_account_activity',$data);
        }
    }
}